"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immutable_1 = require("immutable");
var Type_1 = require("./Type");
var TypeNames_1 = require("./TypeNames");
function getCliqueProperties(clique, makePropertyType) {
    var properties = immutable_1.OrderedMap();
    clique.forEach(function (c) {
        c.properties.forEach(function (t, name) {
            var p = properties.get(name);
            if (p === undefined) {
                p = [immutable_1.OrderedSet(), 0, false];
                properties = properties.set(name, p);
            }
            p[1] += 1;
            p[0] = p[0].union(Type_1.nonNullTypeCases(t));
            if (t.isNullable) {
                p[2] = true;
            }
        });
    });
    return properties.map(function (_a, name) {
        var types = _a[0], count = _a[1], haveNullable = _a[2];
        var isNullable = haveNullable || count < clique.size;
        var allNames = types.filter(function (t) { return t.hasNames; }).map(function (t) { return t.getNames(); });
        var typeNames = allNames.isEmpty()
            ? TypeNames_1.makeTypeNames(name, true)
            : allNames.reduce(function (l, r) { return l.union(r); });
        return makePropertyType(typeNames, types, isNullable);
    });
}
exports.getCliqueProperties = getCliqueProperties;
